<template>
  <PageWithHeight>
    <template v-slot:default="props">
      <div class="note">
        <q-toolbar class="note__toolbar" :class="$q.dark.isActive  ? 'bg-dark' : 'bg-white'">
          <q-toolbar-title class="text-primary">
            {{note.title}}
          </q-toolbar-title>

          <q-btn
              v-for="v in views"
              :key="v"
              flat
              dense
              :label="v"
              @click="view = v"
              @dblclick="splitter = 50"
          />
        </q-toolbar>

        <div class="note__main">
          <q-splitter
              v-if="view === 'split'"
              v-model="splitter"
              :style="{height: `calc(100vh - ${props.offset + navHeight}px)`}"
          >
            <template v-slot:before>
              <Writer v-model="note.md"/>
            </template>

            <template v-slot:after>
              <Renderer :html="html"/>
            </template>
          </q-splitter>

          <Writer
              v-if="view === 'md'"
              v-model="note.md"
              :style="{height: `calc(100vh - ${props.offset + navHeight}px)`}"
          />
          <Renderer
              v-if="view === 'html'"
              :html="html"
              :style="{height: `calc(100vh - ${props.offset + navHeight}px)`}"
          />
        </div>
      </div>
    </template>
  </PageWithHeight>
</template>

<style lang="scss">
.note {
  display: flex;
  flex-direction: column;
  align-items: stretch;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;

  &__toolbar {
    border-bottom: 1px solid rgba(0, 0, 0, 0.2);
    gap: 8px;
  }
}
</style>

<script lang="ts">
import {defineComponent} from "vue";

import PageWithHeight from '../components/PageWithHeight.vue';
import Renderer from '../components/Renderer.vue';
import Writer from '../components/Writer.vue';
import {Note} from "../wailsjs/go/models";

const viewsDefinition = ['md', 'split', 'html'] as const;

export default defineComponent({
  components: {
    PageWithHeight,
    Renderer,
    Writer
  },

  data: () => ({
    views: viewsDefinition,
    view: 'split',
    navHeight: 50,
    splitter: 50,
    html: '',
    note: Note.createFrom()
  }),

  watch: {
    note: {
      immediate: true,
      deep: true,
      async handler(note) {
        if (note.title.length > 0) {
          const [formatted] = await Promise.all([
            window.go.main.App.RenderMarkdown(note.md),
            window.go.main.App.StoreNote(note)
          ]);

          this.html = formatted;
        }
      }
    },

    '$route.params.path': {
      immediate: true,
      async handler(path) {
        console.log(path)
        if (path) {
          this.html = '';
          this.note = await window.go.main.App.ReadNote(path);
        }
      }
    }
  }
})
</script>